diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/ac97/ac97_ext.inc oss-v4.1test0-070624-src-gpl/kernel/framework/ac97/ac97_ext.inc
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/ac97/ac97_ext.inc	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/ac97/ac97_ext.inc	Tue Jun 26 22:19:43 2007
@@ -1178,7 +1178,7 @@
   ac97_devc *devc = mixer_devs[dev]->devc;
 
   if (ctrl < 0 || ctrl > 1)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   tmp = codec_read (devc, 0x1a);
 
@@ -1190,7 +1190,7 @@
   if (cmd == SNDCTL_MIX_WRITE)
     {
       if (value < 0 || value > 7)
-	return -EINVAL;
+	return RETERR(EINVAL);
 
       tmp &= ~(0x7 << (ctrl * 8));
       tmp |= (value << (ctrl * 8));
@@ -1198,7 +1198,7 @@
       return value;
     }
 
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/audio.c oss-v4.1test0-070624-src-gpl/kernel/framework/audio/audio.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/audio.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/audio/audio.c	Wed Jun 27 00:41:02 2007
@@ -269,11 +269,11 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (fmt == 0)
     return adev->user_parms.fmt;
@@ -443,11 +443,11 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (ch == 0)
     return adev->user_parms.channels;
@@ -459,7 +459,7 @@
       cmn_err (CE_WARN,
 	       "Audio engine %d: Internal error in channel setup, err=%d, ch=%d\n",
 	       dev, ret, ch);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (ch > 2 && ch > ret)	/* Requested multi channel mode not possible */
@@ -517,11 +517,11 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (rate == 0)
     return adev->user_parms.rate;
@@ -594,7 +594,7 @@
   if (adev == NULL)
     {
       cmn_err (CE_WARN, "oss_alloc_dmabuf: adev==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return __oss_alloc_dmabuf (dev, dmap, adev->dmabuf_alloc_flags,
@@ -639,7 +639,7 @@
   if (dmap->osdev == NULL)
     {
       cmn_err (CE_WARN, "dmap->osdev==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (dmap->dmabuf == NULL)
@@ -1325,18 +1325,18 @@
 #endif
 
   if (dev < 0 || dev >= num_audio_engines || audio_engines == NULL)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (adev->unloaded)
-    return -ENODEV;
+    return RETERR(ENODEV);
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   if (adev->osdev == NULL)
     {
       cmn_err (CE_WARN, "adev->osdev==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   open_flags = get_open_flags (mode, open_flags, file);
@@ -1347,7 +1347,7 @@
     {
       MUTEX_EXIT_IRQRESTORE (adev->mutex, flags);
       oss_unreserve_device (adev->osdev);
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
   adev->open_mode = mode;
   MUTEX_EXIT_IRQRESTORE (adev->mutex, flags);
@@ -1609,7 +1609,7 @@
 
   if (dev < 0 || dev >= num_audio_devfiles)
     {
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
   adev = audio_devfiles[dev];
 
@@ -1663,10 +1663,10 @@
     {
       DDB (cmn_err (CE_CONT, "Trying engine=%d\n", adev->engine_num));
       if (!adev->enabled)
-	return -EAGAIN;
+	return RETERR(EAGAIN);
 
       if (adev->unloaded)
-	return -EAGAIN;
+	return RETERR(EAGAIN);
 
       *newdev = adev->engine_num;
       if ((err =
@@ -1677,7 +1677,7 @@
 	   * Check if the device was busy and if it has a
 	   * shadow device.
 	   */
-	  if (err != -EBUSY || adev->next_out == NULL)
+	  if (err != RETERR(EBUSY) || adev->next_out == NULL)
 	    return err;
 	  adev = adev->next_out;
 	}
@@ -1689,7 +1689,7 @@
 	}
     }
 
-  return -EBUSY;
+  return RETERR(EBUSY);
 
 done:
 /*
@@ -2254,7 +2254,7 @@
 #ifdef DO_TIMINGS
       oss_do_timing ("GETOSPACE: Bad access mode - return EACCES");
 #endif
-      return -EACCES;
+      return RETERR(EACCES);
     }
 
   if (dmap->mapping_flags & DMA_MAP_MAPPED)
@@ -2274,7 +2274,7 @@
        * Applications that use mmap can call SNDCTL_DSP_GETOSPACE before calling
        * mmap to get the actual buffer size.
        */
-      return -EPERM;
+      return RETERR(EPERM);
     }
 
   if (!(dmap->flags & DMAP_STARTED))
@@ -2381,7 +2381,7 @@
       MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
       cmn_err (CE_WARN,
 	       "SNDCTL_DSP_GETISPACE cannot be called in write-only mode.\n");
-      return -EACCES;
+      return RETERR(EACCES);
     }
 
   if (dmap->mapping_flags & DMA_MAP_MAPPED)
@@ -2398,7 +2398,7 @@
        * Applications that use mmap can call SNDCTL_DSP_GETISPACE before calling
        * mmap to get the actual buffer size.
        */
-      return -EPERM;
+      return RETERR(EPERM);
     }
 
   if (!(dmap->flags & DMAP_STARTED))
@@ -2524,7 +2524,7 @@
 
   if (adev->sync_group != 0)
     {
-      return -EBUSY;
+      return RETERR(EBUSY);
     }
 
   if (group->id == 0)
@@ -2532,7 +2532,7 @@
       if (adev->engine_num > 0xff)
 	{
 	  cmn_err (CE_WARN, "Bad device number %d\n", adev->engine_num);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       id = xrand (sync_seed) & ~0xff;
@@ -2551,7 +2551,7 @@
   if (sync_dev < 0 || sync_dev >= num_audio_engines)
     {
       group->id = 0;
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   sync_adev = audio_engines[sync_dev];
@@ -2562,12 +2562,12 @@
     {
       if (!(sync_adev->sync_flags & SYNC_MASTER))
 	{
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       if (sync_adev->sync_group != id)
 	{
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 	}
 
       adev->sync_flags |= SYNC_SLAVE;
@@ -2578,7 +2578,7 @@
   if (group->mode == 0)
     {
       adev->sync_flags = 0;
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   adev->sync_mode = group->mode;
@@ -2603,12 +2603,12 @@
 
   master_dev = group & 0xff;
   if (master_dev < 0 || master_dev >= num_audio_engines)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   adev = audio_engines[master_dev];
 
   if (adev->sync_group != group)
-    return -EINVAL;
+    return RETERR(EINVAL);
 
   while (adev != NULL)
     {
@@ -2966,13 +2966,13 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (adev->unloaded)
-    return -ENODEV;
+    return RETERR(ENODEV);
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
   dmapout = adev->dmap_out;
   dmapin = adev->dmap_in;
 
@@ -2983,7 +2983,7 @@
   if ((mixdev = adev->mixer_dev) != -1)
     {
       if (((cmd >> 8) & 0xff) == 'M' && num_mixers > 0)	/* Mixer ioctl */
-	if ((ret = oss_legacy_mixer_ioctl (mixdev, dev, cmd, arg)) != -EINVAL)
+	if ((ret = oss_legacy_mixer_ioctl (mixdev, dev, cmd, arg)) != RETERR(EINVAL))
 	  return ret;
 
       if (((cmd >> 8) & 0xff) == 'X')	/* Mixer extension API */
@@ -3076,7 +3076,7 @@
 				       "GETOSPACE called in read-only mode"),
 			       0);
 	  /* Errordesc: SNDCTL_DSP_GETOSPACE is not defined in read-only access mode */
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       ret = get_ospace (adev, dmapout, arg);
 #ifdef DO_TIMINGS
@@ -3106,7 +3106,7 @@
 	   * Errordesc: SNDCTL_DSP_GETISPACE has no defined meaning when the audio
 	   * device is opened in write-only mode.
 	   */
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
 
       return get_ispace (adev, dmapin, arg);
@@ -3119,7 +3119,7 @@
 			       OSSERR (1005,
 				       "GETODELAY called in read-only mode"),
 			       0);
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       return get_odelay (adev, dmapout, arg);
       break;
@@ -3131,19 +3131,19 @@
 			       OSSERR (1006,
 				       "SETDUPLEX called in non-read/write mode"),
 			       0);
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       if (adev->flags & ADEV_DUPLEX)
 	{
 	  val = adev->d->ioctl (dev, cmd, arg);
-	  if (val == -EINVAL)
+	  if (val == RETERR(EINVAL))
 	    return 0;
 	  else
 	    return val;
 	}
       else
 	{
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       break;
 
@@ -3232,7 +3232,7 @@
     case SNDCTL_DSP_GETCHANNELMASK:
     case SNDCTL_DSP_BIND_CHANNEL:
       if (adev->d->bind == NULL)
-	return -EINVAL;
+	return RETERR(EINVAL);
       return adev->d->bind (adev->engine_num, cmd, arg);
       break;
 
@@ -3244,7 +3244,7 @@
 	  {
 	    cmn_err (CE_NOTE, "Device %d doesn't have trigger capability\n",
 		     adev->engine_num);
-	    return -EIO;
+	    return RETERR(EIO);
 	  }
 
 	val = *arg;
@@ -3299,7 +3299,7 @@
 	{
 	  cmn_err (CE_NOTE, "Device %d doesn't have trigger capability\n",
 		   adev->engine_num);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       return *arg = (adev->enable_bits & adev->open_mode);
       break;
@@ -3361,12 +3361,12 @@
 	    && mixdev < num_mixers)
 	  mixer_devs[mixdev]->modify_counter++;
 
-	if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)
+	if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))
 	  {
 	    /* Emulate these calls using mixer API */
 
 	    if (mixdev < 0 || mixdev >= num_mixers)
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 
 	    if (cmd == SNDCTL_DSP_GETPLAYVOL)
 	      cmd = SOUND_MIXER_READ_PCM;
@@ -3387,12 +3387,12 @@
 	if (cmd == SNDCTL_DSP_SETRECVOL && mixdev >= 0 && mixdev < num_mixers)
 	  mixer_devs[mixdev]->modify_counter++;
 
-	if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)
+	if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))
 	  {
 	    /* Emulate these calls using mixer API */
 
 	    if (mixdev < 0 || mixdev >= num_mixers)
-	      return -EINVAL;
+	      return RETERR(EINVAL);
 
 	    /* Try with RECGAIN */
 	    if (cmd == SNDCTL_DSP_GETRECVOL)
@@ -3429,7 +3429,7 @@
 			       OSSERR (1007,
 				       "GETOPTR called in read-only mode"),
 			       0);
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       return get_optr (adev, dmapout, arg);
       break;
@@ -3441,7 +3441,7 @@
 			       OSSERR (1008,
 				       "GETIPTR called in write-only mode"),
 			       0);
-	  return -ENOTSUP;
+	  return RETERR(ENOTSUP);
 	}
       return get_iptr (adev, dmapin, arg);
       break;
@@ -3449,13 +3449,13 @@
 #ifndef OSS_NO_LONG_LONG
     case SNDCTL_DSP_CURRENT_OPTR:
       if (!(adev->dmask & DMASK_OUT))
-	return -ENOTSUP;
+	return RETERR(ENOTSUP);
       return get_long_optr (adev, dmapout, arg);
       break;
 
     case SNDCTL_DSP_CURRENT_IPTR:
       if (!(adev->dmask & DMASK_IN))
-	return -ENOTSUP;
+	return RETERR(ENOTSUP);
       return get_long_iptr (adev, dmapin, arg);
       break;
 #endif
@@ -3463,7 +3463,7 @@
     case SNDCTL_DSP_POLICY:
       val = *arg;
       if (val < 0 || val > 10)
-	return -EIO;
+	return RETERR(EIO);
       adev->policy = val;
       return 0;
       break;
@@ -3518,11 +3518,11 @@
 	     * supports only mono (0) or stereo (1). For larger number of channels
 	     * you need to use SNDCTL_DSP_CHANNELS instead.
 	     */
-	    return -EINVAL;
+	    return RETERR(EINVAL);
 	  }
 
 	if (n < 0)
-	  return -EINVAL;
+	  return RETERR(EINVAL);
 
 	v = oss_audio_set_channels (dev, n + 1);
 	return *arg = (v - 1);
@@ -3558,7 +3558,7 @@
       break;
 
     case SNDCTL_DSP_GET_RECSRC_NAMES:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  oss_mixer_enuminfo *ei = (oss_mixer_enuminfo *) arg;
 
@@ -3574,7 +3574,7 @@
       break;
 
     case SNDCTL_DSP_GET_RECSRC:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  return *arg = (get_legacy_recsrc (dev));
 	}
@@ -3582,7 +3582,7 @@
       break;
 
     case SNDCTL_DSP_SET_RECSRC:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  val = *arg;
 	  set_legacy_recsrc (dev, val);
@@ -3592,7 +3592,7 @@
       break;
 
     case SNDCTL_DSP_GET_PLAYTGT_NAMES:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  oss_mixer_enuminfo *ei = (oss_mixer_enuminfo *) arg;
 	  memset (ei, 0, sizeof (*ei));
@@ -3604,7 +3604,7 @@
       break;
 
     case SNDCTL_DSP_GET_PLAYTGT:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  return *arg = (0);
 	}
@@ -3612,7 +3612,7 @@
       break;
 
     case SNDCTL_DSP_SET_PLAYTGT:
-      if ((err = adev->d->ioctl (dev, cmd, arg)) == -EINVAL)	/* Not handled */
+      if ((err = adev->d->ioctl (dev, cmd, arg)) == RETERR(EINVAL))	/* Not handled */
 	{
 	  return *arg = (0);
 	}
@@ -3642,7 +3642,7 @@
     default:
       return adev->d->ioctl (dev, cmd, arg);
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 
@@ -3933,7 +3933,7 @@
   if (!(dmap->flags & DMAP_PREPARED))
     {
       cmn_err (CE_WARN, "launch_input while not prepared.\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
 #ifdef DO_TIMINGS
@@ -3989,7 +3989,7 @@
 #ifdef DO_TIMINGS
 	  oss_do_timing ("*** EAGAIN ***");
 #endif
-	  return -EAGAIN;
+	  return RETERR(EAGAIN);
 	}
 
       if (n++ > 100)
@@ -3998,7 +3998,7 @@
 		   adev->engine_num);
 	  cmn_err (CE_CONT, "Counters %d / %d\n", count, lim);
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       tmout = (dmap->fragment_size * OSS_HZ) / dmap->data_rate;
@@ -4030,7 +4030,7 @@
 		   "Input timed out on audio engine %d (count=%lld)\n",
 		   adev->engine_num, dmap->byte_counter);
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}			/* Timed out */
 
 #ifdef DO_TIMINGS
@@ -4041,7 +4041,7 @@
       if (status & WK_SIGNAL)
 	{
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EINTR;
+	  return RETERR(EINTR);
 	}
       count = (int) (dmap->byte_counter - dmap->user_counter);
 #ifdef DO_TIMINGS
@@ -4170,7 +4170,7 @@
     }
 
   cmn_err (CE_NOTE, "oss: Why here?\n");
-  return -EIO;
+  return RETERR(EIO);
 }
 
 int
@@ -4191,17 +4191,17 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if (adev->flags & ADEV_NOINPUT)
-    return -EACCES;
+    return RETERR(EACCES);
   dmap = adev->dmap_in;
 
   if (!(adev->open_mode & OPEN_READ))
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
   if (dmap->dma_mode == PCM_ENABLE_OUTPUT)
     {
       audio_reset_output (adev);
@@ -4240,7 +4240,7 @@
   if (!(dmap->flags & DMAP_PREPARED))
     {				/* Not prepared. Why??? */
       cmn_err (CE_WARN, "Intenal error (not prepared)\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   c = count;
@@ -4251,16 +4251,16 @@
     {
       if ((l = find_input_space (adev, dmap, &dmabuf)) < 0)
 	{
-	  if (l == -EINTR)
+	  if (l == RETERR(EINTR))
 	    {
 	      if (c == count)	/* Nothing read yet */
-		return -EINTR;
+		return RETERR(EINTR);
 	      return count - c;
 	    }
-	  if (l == -EAGAIN)
+	  if (l == RETERR(EAGAIN))
 	    {
 	      if (c == count)	/* Nothing read yet */
-		return -EAGAIN;
+		return RETERR(EAGAIN);
 	      return count - c;
 	    }
 	  return l;
@@ -4272,7 +4272,7 @@
       if (uiomove (dmabuf, l, UIO_READ, buf) != 0)
 	{
 	  cmn_err (CE_WARN, "audio: uiomove(UIO_READ) failed\n");
-	  return -EFAULT;
+	  return RETERR(EFAULT);
 	}
       if ((ret = move_rdpointer (adev, dmap, l)) < 0)
 	{
@@ -4352,7 +4352,7 @@
   if (dmap == NULL)
     {
       cmn_err (CE_WARN, "Internal error - dmap==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   MUTEX_ENTER_IRQDISABLE (dmap->mutex, flags);
@@ -4365,7 +4365,7 @@
 	{
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
 	  cmn_err (CE_WARN, "Internal timeout error B\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if (adev->nonblock || !(adev->enable_bits & PCM_ENABLE_OUTPUT))
@@ -4396,7 +4396,7 @@
 	   * One possible error causing this is that the application has
 	   * triggered only recording on a duplex device.
 	   */
-	  return -EAGAIN;
+	  return RETERR(EAGAIN);
 	}
       if (n++ > dmap->nfrags * 2)
 	{
@@ -4410,7 +4410,7 @@
 #endif
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
 	  audio_reset_output (adev);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       tmout = (dmap->fragment_size * OSS_HZ) / dmap->data_rate;
@@ -4423,7 +4423,7 @@
       if (adev->go == 0)
 	{
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EAGAIN;
+	  return RETERR(EAGAIN);
 	}
 #ifdef DO_TIMINGS
       {
@@ -4460,7 +4460,7 @@
 		       adev->engine_num, adev->name, dmap->byte_counter);
 	    }
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EIO;
+	  return RETERR(EIO);
 	}			/* Timed out */
       DOWN_STATUS (STS_SLEEP);
 
@@ -4479,7 +4479,7 @@
 	  oss_do_timing ("Signal caught");
 #endif
 	  MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-	  return -EINTR;
+	  return RETERR(EINTR);
 	}
 
       len = audio_space_in_queue (adev, dmap, count);
@@ -4517,7 +4517,7 @@
   if (offs < 0 || (offs + len) > dmap->bytes_in_use)
     {
       cmn_err (CE_WARN, "Bad audio output buffer %d/%d\n", offs, len);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   return offs;
@@ -4545,7 +4545,7 @@
   if (!(dmap->flags & DMAP_PREPARED))
     {
       cmn_err (CE_WARN, "launch_output while not prepared.\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
 #ifdef DO_TIMINGS
@@ -4597,7 +4597,7 @@
       cmn_err (CE_WARN, "Buffer overflow %lld+%d, %lld\n", dmap->user_counter,
 	       len, dmap->byte_counter);
       MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   dmap->user_counter += len;
@@ -4669,11 +4669,11 @@
 
       if ((offs = find_output_space (adev, dmap, &spc, l)) < 0)
 	{
-	  if (offs == -EAGAIN)
+	  if (offs == RETERR(EAGAIN))
 	    {
 	      store_tmp_data (adev, dmap, buf + p, count);
 	      launch_output (adev, dmap);
-	      return -EAGAIN;
+	      return RETERR(EAGAIN);
 	    }
 	  return offs;
 	}
@@ -4714,17 +4714,17 @@
   sync_seed++;
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
 
   adev = audio_engines[dev];
   if (!adev->enabled)
-    return -ENXIO;
+    return RETERR(ENXIO);
   if (adev->flags & ADEV_NOOUTPUT)
-    return -EACCES;
+    return RETERR(EACCES);
   dmap = adev->dmap_out;
 
   if (!(adev->open_mode & OPEN_WRITE))
-    return -ENOTSUP;
+    return RETERR(ENOTSUP);
 
   UP_STATUS (STS_WRITE);
 
@@ -4771,7 +4771,7 @@
       MUTEX_EXIT_IRQRESTORE (dmap->mutex, flags);
       DOWN_STATUS (STS_WRITE);
       cmn_err (CE_WARN, "Internal error (not prepared)\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 #if 1
   if (dmap->leftover_bytes > 0)
@@ -4822,7 +4822,7 @@
       if (tmout++ > 1000)
 	{
 	  cmn_err (CE_WARN, "Internal timeout error A (%d/%d)\n", c, count);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       l = c;
@@ -4831,19 +4831,19 @@
 
       if ((offs = find_output_space (adev, dmap, &spc, l)) < 0)
 	{
-	  if (offs == -EINTR)
+	  if (offs == RETERR(EINTR))
 	    {
 	      DOWN_STATUS (STS_WRITE);
 	      if (c == count)	/* Nothing written yet */
-		return -EINTR;
+		return RETERR(EINTR);
 	      return count - c;
 	    }
-	  if (offs == -EAGAIN)
+	  if (offs == RETERR(EAGAIN))
 	    {
 	      DOWN_STATUS (STS_WRITE);
 	      if (c == count)	/* Nothing written yet */
 		{
-		  return -EAGAIN;
+		  return RETERR(EAGAIN);
 		}
 	      return count - c;
 	    }
@@ -4874,7 +4874,7 @@
 		  cmn_err (CE_WARN,
 			   "audio: uiomove(UIO_WRITE) failed (noconv)\n");
 		  DOWN_STATUS (STS_WRITE);
-		  return -EFAULT;
+		  return RETERR(EFAULT);
 		}
 	      if ((err =
 		   dmap->device_write (adev, dmap, tmpbuf,
@@ -4898,7 +4898,7 @@
 		{
 		  cmn_err (CE_WARN,
 			   "audio: uiomove(UIO_WRITE) (noconv2) failed\n");
-		  return -EFAULT;
+		  return RETERR(EFAULT);
 		}
 	      if ((err = move_wrpointer (adev, dmap, l)) < 0)
 		{
@@ -4957,7 +4957,7 @@
 
 	  if ((err = write_copy (adev, dmap, p1, l2)) < 0)
 	    {
-	      if (err != -EAGAIN)
+	      if (err != RETERR(EAGAIN))
 		{
 		  DOWN_STATUS (STS_WRITE);
 		  return err;
@@ -4967,7 +4967,7 @@
 	      if (c == count)	/* Nothing written yet */
 		{
 		  DOWN_STATUS (STS_WRITE);
-		  return -EAGAIN;
+		  return RETERR(EAGAIN);
 		}
 
 	      DOWN_STATUS (STS_WRITE);
@@ -5044,7 +5044,7 @@
   if (audio_devfiles == NULL)
     {
       cmn_err (CE_NOTE, "No audio device files available\n");
-      return -ENXIO;
+      return RETERR(ENXIO);
     }
   oss_combine_write_lists ();
 
@@ -5162,7 +5162,7 @@
 
   DDB (cmn_err (CE_CONT, " - got vdsp -> %d\n", dev));
   if (dev == -1)
-    return -EBUSY;
+    return RETERR(EBUSY);
 
 done:
 /*
@@ -5277,6 +5277,17 @@
       adev->dmap_in->dmabuf = NULL;
     }
 
+  if (adev->in_wq)
+    {
+      oss_remove_wait_queue (adev->in_wq);
+      adev->in_wq = NULL;
+    }
+  if (adev->out_wq)
+    {
+      oss_remove_wait_queue (adev->out_wq);
+      adev->out_wq = NULL;
+    }
+
   MUTEX_CLEANUP (adev->mutex);
 
   MUTEX_CLEANUP (adev->dmap_out->mutex);
@@ -5592,7 +5603,7 @@
 #endif
 
   if (dev < 0 || dev >= num_audio_engines)
-    return -ENXIO;
+    return RETERR(ENXIO);
   adev = audio_engines[dev];
 
   if ((events & (POLLOUT | POLLWRNORM)) && (adev->open_mode & OPEN_WRITE))
@@ -5612,7 +5623,7 @@
 	   * The select() and poll() system calls are not defined for OSS devices
 	   * when the device is in mmap mode.
 	   */
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if (dmap->dma_mode == PCM_ENABLE_INPUT)
@@ -5669,7 +5680,7 @@
 	   * The select() and poll() system calls are not defined for OSS devices
 	   * when the device is in mmap mode.
 	   */
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       if (dmap->dma_mode != PCM_ENABLE_INPUT)
@@ -5974,7 +5985,7 @@
   if (vers != OSS_AUDIO_DRIVER_VERSION)
     {
       cmn_err (CE_WARN, "Incompatible audio driver for %s\n", name);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (driver_size > sizeof (audiodrv_t))
@@ -6007,7 +6018,7 @@
       if (num_audio_engines >= MAX_PCM_DEV)
 	{
 	  cmn_err (CE_NOTE, "Too many audio engines\n");
-	  return -EIO;
+	  return RETERR(EIO);
 	}
       d = PMALLOC (osdev, sizeof (audiodrv_t));
       op = PMALLOC (osdev, sizeof (adev_t));
@@ -6037,7 +6048,7 @@
   if (d == NULL || op == NULL)
     {
       cmn_err (CE_WARN, "Can't allocate driver for (%s)\n", name);
-      return -ENOSPC;
+      return RETERR(ENOSPC);
     }
 
   if (d->get_input_pointer == NULL)
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/audiofmt.c oss-v4.1test0-070624-src-gpl/kernel/framework/audio/audiofmt.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/audiofmt.c	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/audio/audiofmt.c	Tue Jun 26 22:19:44 2007
@@ -272,7 +272,7 @@
 	{
 	  cmn_err (CE_WARN, "SRC failed (%d), bits=%d, ssize=%d\n", err, bits,
 		   ssize);
-	  return -EIO;
+	  return RETERR(EIO);
 	}
 
       *len = ((grc3state_t *) dmap->srcstate[ch])->outsz * ssize * channels;
@@ -325,7 +325,7 @@
   if (nch > 2)
     {
       cmn_err (CE_WARN, "Too many channels for SRC (%d)\n", nch);
-      return -EIO;
+      return RETERR(EIO);
     }
   {
     int val;
@@ -333,7 +333,7 @@
     if (src_open (&dmap->src, srate, trate, nch, 0) != 0)
       {
 	cmn_err (CE_CONT, "OSS audio: SRC open failed\n");
-	return -EIO;
+	return RETERR(EIO);
       }
   }
 #endif
@@ -341,7 +341,7 @@
   if (nch > OSS_MAX_CONVERT_CHANNELS)
     {
       cmn_err (CE_WARN, "Too many channels for SRC (%d)\n", nch);
-      return -EIO;
+      return RETERR(EIO);
     }
 #ifdef DO_TIMINGS
   {
@@ -611,7 +611,7 @@
       default:
 	cmn_err (CE_WARN, "Unsupported conversion source format %08x\n",
 		 source->fmt);
-	return -EIO;
+	return RETERR(EIO);
       }
 
   if (source->rate != target->rate && source->channels <= target->channels)
@@ -931,7 +931,7 @@
       default:
 	cmn_err (CE_WARN, "Unsupported conversion target format %08x\n",
 		 target->fmt);
-	return -EIO;
+	return RETERR(EIO);
       }
 
   VMEM_CHECK (p1, len);
@@ -958,7 +958,7 @@
   if ((fmt = oss_find_format (source->fmt)) == NULL)
     {
       cmn_err (CE_WARN, "Unknown audio format %x\n", source->fmt);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   switch (fmt->bits)
@@ -1131,13 +1131,13 @@
   if ((src_f = oss_find_format (source->fmt)) == NULL)
     {
       cmn_err (CE_CONT, "internal format error 1 (%x)\n", source->fmt);
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if ((tgt_f = oss_find_format (target->fmt)) == NULL)
     {
       cmn_err (CE_CONT, "internal format error 2\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
 #ifdef DO_TIMINGS
@@ -1174,7 +1174,7 @@
 	 "Audio format conversions not supported with more than %d channels\n",
 	 OSS_MAX_CONVERT_CHANNELS);
       dmap->flags &= ~DMAP_COOKED;
-      return -EIO;
+      return RETERR(EIO);
     }
 
   expand = (expand * target->rate) / source->rate;
@@ -1277,7 +1277,7 @@
     }
 
   if (dmap->tmpbuf1 == NULL || dmap->tmpbuf2 == NULL)
-    return -ENOSPC;
+    return RETERR(ENOSPC);
 
   if (cnv & CNV_SRC)
     if (setup_src
@@ -1285,7 +1285,7 @@
 	 target->channels) < 0)
       {
 	cmn_err (CE_CONT, "internal format error 3\n");
-	return -EIO;
+	return RETERR(EIO);
       }
 
   return 0;
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/spdif.c oss-v4.1test0-070624-src-gpl/kernel/framework/audio/spdif.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/audio/spdif.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/audio/spdif.c	Tue Jun 26 22:19:44 2007
@@ -63,7 +63,7 @@
   if (d == NULL || driver_size != sizeof (spdif_driver_t))
     {
       cmn_err (CE_WARN, "spdif: Bad driver\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   memset (devc, 0, sizeof (*devc));
@@ -94,7 +94,7 @@
   if (!devc->is_ok)
     {
       cmn_err (CE_WARN, "spdif: Bad usage - open\n");
-      return -EIO;
+      return RETERR(EIO);
     }
   MUTEX_ENTER (devc->mutex, flags);
   devc->open_mode |= open_mode;
@@ -224,7 +224,7 @@
       else
 	{
 	  if (valid != 0)	/* Can't get input status */
-	    ret = -EIO;
+	    ret = RETERR(EIO);
 	}
     }
 
@@ -235,7 +235,7 @@
 static int
 handle_request (spdif_devc * devc, oss_digital_control * c)
 {
-  return -EIO;
+  return RETERR(EIO);
 }
 
 static int
@@ -321,15 +321,15 @@
     {
     case SNDCTL_DSP_WRITECTL:
       if (!(open_mode & OPEN_WRITE))	/* Not opened for output */
-	return -ENOTSUP;
+	return RETERR(ENOTSUP);
       if (!(devc->flags & SPDF_OUT))
-	return -ENOTSUP;
+	return RETERR(ENOTSUP);
       return writectl (devc, (oss_digital_control *) arg);
       break;
 
     case SNDCTL_DSP_READCTL:
       if (!(devc->flags & (SPDF_OUT | SPDF_IN)))
-	return -ENOTSUP;
+	return RETERR(ENOTSUP);
       return readctl (devc, (oss_digital_control *) arg, open_mode);
       break;
     }
@@ -374,7 +374,7 @@
 	  return devc->ctl->emphasis_type;
 	}
 
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
 
   if (cmd == SNDCTL_MIX_WRITE)
@@ -452,9 +452,9 @@
 	  break;
 	}
 
-      return -EINVAL;
+      return RETERR(EINVAL);
     }
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -469,7 +469,7 @@
       devc = devc_list[i];
 
   if (devc == NULL)
-    return -EINVAL;
+    return RETERR(EINVAL);
   MUTEX_ENTER (devc->mutex, flags);
   ret = spdif_set_control (devc, ctrl, cmd, value);
   MUTEX_EXIT (devc->mutex, flags);
@@ -486,7 +486,7 @@
   if (!devc->is_ok)
     {
       cmn_err (CE_WARN, "spdif: Bad usage - mix_init\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   if (devc->group > 0)
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/include/oss_config.h oss-v4.1test0-070624-src-gpl/kernel/framework/include/oss_config.h
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/include/oss_config.h	Sun Jun 24 18:09:42 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/include/oss_config.h	Wed Jun 27 17:21:06 2007
@@ -313,6 +313,12 @@
 extern void oss_audio_set_error (int dev, int mode, int err, int parm);
 #define OSSERR(cntx, msg) cntx
 
+#if EINVAL > 0
+#define RETERR(e) (-(e))
+#else
+#define RETERR(e) (e)
+#endif
+
 /*
  * Ensure that various obsolete OSS 3.x features are not used any more
  * in the drivers.
diff -urN oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/default_timer.c oss-v4.1test0-070624-src-gpl/kernel/framework/midi/default_timer.c
--- oss-v4.1test0-070624-src-gpl.org/kernel/framework/midi/default_timer.c	Sun Jun 24 18:09:41 2007
+++ oss-v4.1test0-070624-src-gpl/kernel/framework/midi/default_timer.c	Tue Jun 26 22:19:44 2007
@@ -32,7 +32,7 @@
   deftmr_timerc_t *timerc;
 
   if ((timerc = KERNEL_MALLOC (sizeof (*timerc))) == NULL)
-    return -ENOMEM;
+    return RETERR(ENOMEM);
 
   memset (timerc, 0, sizeof (*timerc));
 
@@ -68,7 +68,7 @@
 static int
 deftmr_ioctl (int timer_dev, unsigned int cmd, ioctl_arg arg)
 {
-  return -EINVAL;
+  return RETERR(EINVAL);
 }
 
 static int
@@ -98,7 +98,7 @@
   if (timerc == NULL)
     {
       cmn_err (CE_WARN, "deftmr_start: timerc==NULL\n");
-      return -EIO;
+      return RETERR(EIO);
     }
 
   timerc->start_time = GET_JIFFIES ();
